/*  Ofront 1.2 -xtspkae */

#include "SYSTEM.h"

export BOOLEAN Keyboard_PressedAnyKey (void);
export BOOLEAN Keyboard_Pressed (CHAR key);

#define KEY_UP    0x39
#define KEY_DOWN  0x38
#define KEY_LEFT  0x36
#define KEY_RIGHT 0x37

BOOLEAN Keyboard_Pressed (CHAR key)
{
__asm
    LD   L,#0     ; FALSE
    LD   A,4(IX)  ; key
    POP  IX
    CP   #KEY_UP
    JP   NZ,KEY1$
    LD   A,#0xFB  ;   ,
    IN   A,(#254) ;      Q
    RRCA          ;  Q     
    RET  C        ;   (  )
    INC  L
    RET
KEY1$:
    cp    #KEY_DOWN
    jp    nz,KEY2$
    LD    A,#253
    IN    A,(#254)
    RRCA              ; A
    RET   C
    inc   l
    ret
KEY2$:
    cp    #KEY_RIGHT
    jp    nz,KEY3$
    LD    A,#223
    IN    A,(#254)
    RRCA              ; P
    RET   C
    inc   l
    ret
KEY3$:
    cp    #KEY_LEFT
    jp    nz,KEY4$
;    P  O    ,
;     IN   
    LD    A,#223
    IN    A,(#254)
    RRCA
    RRCA              ; O
    RET   C
    inc   l
    ret
KEY4$:
    RET
__endasm;
} /*Keyboard_Pressed*/

BOOLEAN Keyboard_PressedAnyKey (void)
{
__asm
    call  #0x28E     ; Scan keys
    ld    l,#0       ; FALSE
    inc   de
    ld    a,e
    or    d
    ret   z
    inc   l          ; TRUE
__endasm;
} /*Keyboard_PressedAnyKey*/

export void *Keyboard__init(void)
{
	__DEFMOD;
	__REGMOD("Keyboard", 0);
	__REGCMD("Close", Keyboard_Close);
/* BEGIN */
	__ENDMOD;
}
