@REM Prepare the Basic from Ofront
@REM =============================
@COPY /Y /B Libs\Basic.h Basic.h
@IF EXIST Basic.c DEL /Q Basic.c

@REM Prepare library "Keyboard"
@REM ==========================
@IF NOT EXIST Keyboard.rel CALL Keyboard.bat

@REM Compile MoveSpr.c
@REM ====================
Bin\sdcc -mz80 --code-loc 26000 --data-loc 0xF800 --no-std-crt0 --opt-code-size --funsigned-char -L Libs/z80 MoveSpr.c Keyboard.rel Basic.lib Laser.lib

@REM Convert Intel hex format to binary
@REM ==================================
@REM Bin\makebin -p MoveSpr.ihx MoveSpr.bin
Bin\Hex2bin MoveSpr.ihx
REM Bin\stripbin MoveSpr.bin

@REM Link the target to TR-DOS format
@REM ================================
REM WARNING! bin2trd is a MS-DOS program, must use a short filename
@DEL /Q MoveSpr.TRD
Bin\bin2trd.exe MoveSpr.trl
@MOVE /Y MoveSpr.TRD MoveSpr.trd

@REM ======================================================================
@ECHO Now you can run the image "MoveSpr.trd" in your favourite emulator
@REM ======================================================================

@PAUSE
